## metview 5.26.1

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

include( ${INCLUDE_CONFIG}-local-config.cmake OPTIONAL )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
#set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )


project( MetviewMiniBundle VERSION 5.26.1 LANGUAGES C CXX )
set(CPACK_PACKAGE_NAME Metview)  # so that the source tarball will have the name 'Metview'


# list all the packages we incorporate into the bundle
set(MV_BUNDLE_PACKAGES METVIEW MARS_CLIENT MIR ATLAS ECKIT)

if(METVIEW_SITE STREQUAL ecmwf )
    #list(APPEND MV_BUNDLE_PACKAGES FDB)
endif()

# create a variabe for each package we bundle
foreach (bunpack ${MV_BUNDLE_PACKAGES})
    set(MV_BUNDLE_CONTAINS_${bunpack} 1)
endforeach()


# -------------------------------------------------------------------------------------
# settings which are required across the packages to get a working Metview installation

#general
set(ENABLE_ODB           OFF CACHE BOOL "ODB support")
set(ENABLE_EXPERIMENTAL  OFF CACHE BOOL "Experimental features")
set(ENABLE_FORTRAN       NOT_SET CACHE BOOL "Fortran features")

#mars
set(ECMWF             OFF CACHE BOOL "build the client as for ECMWF")
set(CONFIG_FDB        OFF CACHE BOOL "database configuration to access FDB")
set(ENABLE_UDP_STATS  OFF CACHE BOOL "")
set(ENABLE_MPI        OFF CACHE BOOL "")
set(ENABLE_BUILD_TOOLS  OFF   CACHE BOOL   "")


# if the user did bot supply a value for ENABLE_FORTRAN, then unset it
# (we want to then use the default behaviour, per package)
if(ENABLE_FORTRAN STREQUAL "NOT_SET")
    unset(ENABLE_FORTRAN)
    unset(ENABLE_FORTRAN CACHE)
endif()


# -------------------------------------------------------------------------------------

macro(my_bundle_pkg)
    ecbuild_bundle( ${ARGV} )
endmacro()

include( ecbuild_bundle )

ecbuild_bundle_initialize()

    ecbuild_add_option( FEATURE EXPOSE_SUBPACKAGES
                        DEFAULT OFF
                        DESCRIPTION "Allow separate use of the sub-packages in the bundle")



    # if the installer does not want to expose the sub-packages then we need to:
    # a) change $PREFIX so that everything is installed into a sub-directory
    # b) change the location of the Metview startup script so it's installed
    #    where intended (Metview takes care of this)

    if (NOT ENABLE_EXPOSE_SUBPACKAGES)
        set(ORIGINAL_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
        set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib/metview-bundle")
    endif()


    if(MV_BUNDLE_CONTAINS_FDB)
        set( FDB_CONF_FILE /usr/local/apps/fdb/etc/Config )
        list(APPEND MV_BUNDLE_PACKAGES FDB)
        ecbuild_bundle( PROJECT fdb                GIT "ssh://git@git.ecmwf.int/mars/fdb_vintage"    TAG  4.11.0   )
    else()
        set(FDB_DIR "/dummy/path/for/bundle")
    endif()

    my_bundle_pkg( PROJECT eckit        GIT "ssh://git@git.ecmwf.int/ecsdk/eckit"       TAG  1.32.1   )
    #my_bundle_pkg( PROJECT atlas        GIT "ssh://git@git.ecmwf.int/atlas/atlas"       TAG  0.44.0   )
    my_bundle_pkg( PROJECT atlas        GIT "https://github.com/ecmwf/atlas.git"       TAG  0.44.0   )
    #my_bundle_pkg( PROJECT mir          GIT "ssh://git@git.ecmwf.int/mir/mir"           TAG  1.23.0   )
    my_bundle_pkg( PROJECT mir          GIT "https://github.com/ecmwf/mir.git"           TAG  1.27.8   )
    my_bundle_pkg( PROJECT mars-client  GIT "ssh://git@git.ecmwf.int/mars/mars-client"  TAG  6.33.25  )
    my_bundle_pkg( PROJECT metview      GIT "ssh://git@git.ecmwf.int/metv/metview"      TAG  5.26.1   )

    ecbuild_dont_pack(FILES configure.sh;ecmwf;make-tarball.sh;test-tarball.sh;configure.clang.sh;bamboo)

ecbuild_bundle_finalize()


ecbuild_info("ENABLE_EXPOSE_SUBPACKAGES is ${ENABLE_EXPOSE_SUBPACKAGES}:")
if (ENABLE_EXPOSE_SUBPACKAGES)
    ecbuild_info("All packages in the bundle will be installed at the same level into:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
else()
    ecbuild_info("All packages in the bundle will be installed into a sub-directory:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
    ecbuild_info ("The Metview startup script will be installed into:")
    ecbuild_info("  ${ORIGINAL_CMAKE_INSTALL_PREFIX}/bin")
endif()

=== atlas/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# Atlas

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

################################################################################
# Initialise project Atlas

project( atlas LANGUAGES CXX )

set( ATLAS_BITS_GLOBAL 64 CACHE STRING "bits used to define a global index (atlas::gidx_t)" )
set( ATLAS_BITS_LOCAL  32 CACHE STRING "bits used to define a local index (atlas::idx_t)" )

################################################################################
# Required packages

if( ATLAS_BITS_LOCAL MATCHES 64 )
  ecbuild_find_package( NAME eckit VERSION 1.17.1 REQUIRED )
else()
  ecbuild_find_package( NAME eckit VERSION 1.16 REQUIRED )
endif()

ecbuild_debug( "   eckit_FEATURES : [${eckit_FEATURES}]" )

add_subdirectory(atlas_io)
find_package(atlas_io)

################################################################################
# Features that can be enabled / disabled with -DENABLE_<FEATURE>

ecbuild_add_option( FEATURE ATLAS_GRID
                    DESCRIPTION "Build grid related features" )

ecbuild_add_option( FEATURE ATLAS_FIELD
                    DESCRIPTION "Build field and memory management related features" )

ecbuild_add_option( FEATURE ATLAS_FUNCTIONSPACE
                    DESCRIPTION "Build functionspace related features (mesh, functionspace, parallel)"
                    CONDITION atlas_HAVE_ATLAS_GRID AND atlas_HAVE_ATLAS_FIELD )

ecbuild_add_option( FEATURE ATLAS_INTERPOLATION
                    DESCRIPTION "Build interpolation related features"
                    CONDITION atlas_HAVE_ATLAS_FUNCTIONSPACE )

ecbuild_add_option( FEATURE ATLAS_TRANS
                    DESCRIPTION "Build transform related features"
                    CONDITION atlas_HAVE_ATLAS_FUNCTIONSPACE )

ecbuild_add_option( FEATURE ATLAS_NUMERICS
                    DESCRIPTION "Build numerics related features"
                    CONDITION atlas_HAVE_ATLAS_FUNCTIONSPACE )

ecbuild_add_option( FEATURE ECKIT_DEVELOP
                    DESCRIPTION "Used to enable new features or API depending on eckit develop branch, not yet in a tagged release"
                    DEFAULT OFF )

ecbuild_add_option( FEATURE FCKIT_DEVELOP
                    DESCRIPTION "Used to enable new features or API depending on eckit develop branch, not yet in a tagged release"
                    DEFAULT OFF )

if (DEFINED ATLAS_ENABLE_CUDA AND NOT DEFINED HIC_ENABLE_CUDA )
  set( HIC_ENABLE_CUDA ${ATLAS_ENABLE_CUDA} )
endif()
if (DEFINED ATLAS_ENABLE_HIP AND NOT DEFINED HIC_ENABLE_HIP )
  set( HIC_ENABLE_HIP ${ATLAS_ENABLE_HIP} )
endif()

add_subdirectory( hic )
find_package(hic REQUIRED)

add_subdirectory( pluto )
find_package(pluto REQUIRED)

include( features/BOUNDSCHECKING )
include( features/FORTRAN )
include( features/CUDA )
include( features/MPI )
include( features/OMP )
include( features/POCKETFFT )
include( features/FFTW )
include( features/ECTRANS )
include( features/TESSELATION )
include( features/GRIDTOOLS_STORAGE )
include( features/ACC )
include( features/EIGEN )
include( features/PROJ )
include( features/SANDBOX )
include( features/CLANG_TIDY )
include( features/INCLUDE_WHAT_YOU_USE )
include( features/INIT_SNAN )
include( features/DOCS )
include( features/ATLAS_RUN )

################################################################################
# sources

include( atlas_compile_flags )

add_subdirectory( src )
add_subdirectory( doc )

################################################################################
# Export and summarize

include( atlas_export )

ecbuild_print_summary()

=== mars-client/CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

#################################################################################################################################################################

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( mars_client LANGUAGES C CXX )

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#################################################################################################################################################################
### dependencies

option( ECMWF "build the client as for ECMWF"  OFF )

### eccodes

ecbuild_find_package( NAME eccodes VERSION 0.14 REQUIRED )

### eckit

ecbuild_add_option( FEATURE UDP_STATS
  DESCRIPTION "Send statistics over UDP"
  DEFAULT ON
  REQUIRED_PACKAGES "NAME eckit VERSION 1.19" )

if( HAVE_UDP_STATS )
    list( APPEND MARS_FEATURE_LIBRARIES eckit )
endif()

### mir

ecbuild_add_option( FEATURE PPROC_MIR
    DESCRIPTION "compile with MIR interpolation"
    DEFAULT ON
    REQUIRED_PACKAGES
        "NAME mir VERSION 1.5"
        "NAME eckit VERSION 1.19" )

if( HAVE_PPROC_MIR )
    list( APPEND MARS_FEATURE_LIBRARIES mir eckit_linalg )
endif()

### libemos

ecbuild_add_option( FEATURE PPROC_EMOS
    DESCRIPTION "compile with EMOSLIB interpolation"
    DEFAULT ON
    REQUIRED_PACKAGES "NAME libemos" )

if( HAVE_PPROC_EMOS )
    list( APPEND MARS_FEATURE_LIBRARIES emos )
endif()


ecbuild_add_option( FEATURE BUFR_TOOLS
    DESCRIPTION "compile BUFR tools"
    DEFAULT ON
    REQUIRED_PACKAGES "NAME libemos" )

### odb

ecbuild_add_option( FEATURE ODB
    DESCRIPTION "compile with ODB support"
    DEFAULT ON
    REQUIRED_PACKAGES
        "NAME odc VERSION 1.0.3"
        "NAME metkit VERSION 1.4.0" )

if( HAVE_ODB )
  list( APPEND MARS_FEATURE_LIBRARIES odccore metkit )
endif()


ecbuild_add_option( FEATURE BUILD_TOOLS
    DEFAULT ON
    DESCRIPTION "Build the command line tools"
)

ecbuild_add_option( FEATURE MARS_USER_ENVIRONMENT
    DESCRIPTION "Mars user will be in $MARS_USER"
    DEFAULT OFF
)

ecbuild_add_option( FEATURE FDB
    DEFAULT ${ECMWF}
    DESCRIPTION "support for FDB"
    REQUIRED_PACKAGES "NAME fdb VERSION 4.6" )

if( HAVE_FDB )
  list( APPEND MARS_FEATURE_LIBRARIES fdb )
endif()

ecbuild_add_option( FEATURE FDB5
    DEFAULT ${ECMWF}
    DESCRIPTION "support for FDB5"
    REQUIRED_PACKAGES "NAME fdb5 VERSION 5.0" )

if( HAVE_FDB5 )
    list( APPEND MARS_FEATURE_LIBRARIES fdb5 )
endif()

### netcdf

ecbuild_add_option( FEATURE NETCDF
    DEFAULT ON
    DESCRIPTION "support for NetCDF"
    REQUIRED_PACKAGES NetCDF )

if( HAVE_NETCDF )
  list( APPEND MARS_FEATURE_LIBRARIES NetCDF::NetCDF_C )
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DEFAULT ON
                    DESCRIPTION "Curl library for HTTP web based api"
                    REQUIRED_PACKAGES CURL )

### others

find_package( CMath )

ecbuild_add_option( FEATURE RPC
                    DEFAULT ON
                    DESCRIPTION "support for RPC in MARS"
                    REQUIRED_PACKAGES RPC )

if( HAVE_RPC )
  # For transitive dependency
  install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/FindRPC.cmake
    DESTINATION ${INSTALL_CMAKE_DIR} )
endif()


set( CMAKE_THREAD_PREFER_PTHREAD 1 ) # find thread library, but prefer pthreads
find_package(Threads REQUIRED)

ecbuild_add_option( FEATURE ECMWF_DEVELOPMENT
    DEFAULT OFF
    DESCRIPTION "Special mode for development, activates ECMWF but deactivates auth, ems and schedule" )

########################################################################################################################
# sanity checks -- these are more pain than helpful to be honest

if(ECMWF)

    if( NOT HAVE_PPROC_MIR AND NOT HAVE_PPROC_EMOS  )
        message( FATAL_ERROR "At ECMWF mars-client requires PPROC (for which MIR or EMOSLIB is required)" )
    endif()

    if( NOT transi_HAVE_FFTW AND NOT atlas_HAVE_FFTW )
        message( FATAL_ERROR "At ECMWF FFTW library is required" )
    endif()

    if( NOT HAVE_ODB )
      message( FATAL_ERROR "At ECMWF mars-client requires ODB" )
    endif()

endif()

########################################################################################################################
### build source code

add_subdirectory( src )
add_subdirectory( tests )

########################################################################################################################
### finalize

ecbuild_install_project( NAME mars-client )

ecbuild_print_summary() # prints the summary of the configuration

=== metview/CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
#
#  Metview-specific:
#  -DMETVIEW_SITE=ecmwf | other
#  -DMETVIEW_SCRIPT=name-of-generated-startup-script
#  -DMARS_HOME=/path/to/MARS/home  (requires WITH_MARS=ON)
#  -DMAGICS_PATH=/path/to/magics   (requires WITH_PLOTTING=ON)
#  -DEXTRA_TITLE=extra-title-string
#  -DLOG_DIR=/path/to/dir/for/module/log/files
#  -DODB1_USE_SCRIPT_PATH=/path/to/odb1/use/script

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

 
if(POLICY CMP0025)
  cmake_policy(SET CMP0025 NEW)
endif()


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
else()
    set(MV_BIN_DIR bin/metview_bin)
endif()

# set INSTALL_BIN_DIR before calling project()
# so that the installation rpaths are set correctly
set(ORIGINAL_INSTALL_BIN_DIR ${INSTALL_BIN_DIR}) # will restore at the end
set(INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

project(metview LANGUAGES C CXX)


set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)



include( ecbuild_system NO_POLICY_SCOPE )

IF(APPLE)
  SET(MACOSX_RPATH 1)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  #SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
ENDIF(APPLE)

ecbuild_requires_macro_version( 1.9 )

#ecbuild_add_cxx11_flags()  # Magics 3 requires C++11/14
set (CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set (CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

###############################################################################
# some options of this project

option( ENABLE_UI             "enable the user interface"                          ON )
option( ENABLE_PLOTTING       "enable the plotting module"                         ON )
option( ENABLE_MARS           "enable MARS access"                                 OFF )
option( ENABLE_ODB            "enable ODB"                                         OFF )
option( ENABLE_USAGE_LOG      "enable usage logging (only at ECMWF)"               OFF )
option( ENABLE_QT_DEBUG       "enable Qt debugging messages"                       OFF )
option( ENABLE_INPE           "enable INPE modules"                                OFF )
option( ENABLE_URL_DOWNLOAD   "enable downloading of files from URLs"              ON )
option( ENABLE_WEATHER_ROOM   "enable Weather Room plot export (only at ECMWF)"    OFF )
option( ENABLE_SHARE_PLOT     "enable sharing of plots (only at ECMWF)"            OFF )
option( ENABLE_SHARE_TO_GLOBE "enable Globe plot export (only at ECMWF)"           OFF )
option( ENABLE_NETWORK_PROXY  "enable network proxy settings for WMS"              OFF )
option( ENABLE_EXPERIMENTAL   "enable experimental modules"                        OFF )
option( ENABLE_CONTRIB        "enable externally contributed modules"              OFF )
option( ENABLE_METVIEW_FORTRAN "enable modules which use Fortran code"             OFF )
option( ENABLE_METVIEW_DOCS   "enable building of documentation"                   OFF )
option( ENABLE_CODES_UI       "enable building of CodesUI"                         OFF )
option( ENABLE_STVL           "enable STVL access module"                          OFF )
option( ENABLE_STATIONS_DB    "enable database of WMO stations"                    ON )
option( ENABLE_FLEXTRA_TEST   "enable testing FLEXTRA simulations"                 OFF)
option( ENABLE_FLEXPART_TEST  "enable testing FLEXPART simulations"                OFF)
option( ENABLE_QRC_LOCAL_DEV  "enable local development option for qrc files"      OFF)
#option( ENABLE_CODE_WEBHELP   "enable inline web help in code editor"              OFF )




###############################################################################


if( ENABLE_METVIEW_FORTRAN )
    ecbuild_enable_fortran( REQUIRED )
    set(HAVE_METVIEW_FORTRAN 1)
endif()



# if we don't explicitly state that we're at ECMWF, then assume we're not, and use the generic config
if(NOT METVIEW_SITE STREQUAL ecmwf)
    set( SITE_WMO_CODE "255")    # DO WE NEED AN OPTION TO ALLOW INSTALLERS TO SPECIFY THIS?
    set( MV_ENVIRON    "common")
    set( AT_ECMWF "FALSE" )
    ecbuild_info("Building outside ECMWF")
else()
    set( SITE_WMO_CODE "098")
    set( MV_ENVIRON    "ecm_lnx64")
    set( AT_ECMWF "TRUE" )
    add_definitions( -DECMWF )
    ecbuild_info("Building inside ECMWF")
endif()



# default startup script name
if(NOT DEFINED METVIEW_SCRIPT )
    set( METVIEW_SCRIPT "metview" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${METVIEW_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)


# STVL
if (ENABLE_STVL)
    if(DEFINED MV_STVL_EXE)
        if(NOT EXISTS ${MV_STVL_EXE})
            ecbuild_critical("MV_STVL_EXE: (${MV_STVL_EXE}) defined but does not exist")
        endif()
    else()
        ecbuild_critical("MV_STVL_EXE must be defined if ENABLE_STVL is on")
    endif()
endif()

# Weather Room plot export (ECMWF only)
if(ENABLE_WEATHER_ROOM)
    if(AT_ECMWF)
        find_package( Boost 1.49.0 )            # Weather Room export needs Boost
        set(MV_WEATHER_ROOM_BUILT true)
    else()
        ecbuild_error("ENABLE_WEATHER_ROOM only available when building at ECMWF")
    endif()
else()
    set(MV_WEATHER_ROOM_BUILT false)
endif()

# Globe plot export (ECMWF only)
if(ENABLE_SHARE_TO_GLOBE)
    if(NOT AT_ECMWF)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when building at ECMWF")
    endif()
    if(NOT ENABLE_SHARE_PLOT)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when ENABLE_SHARE_PLOT is enabled")
    endif()
endif()


# Meteogram (ECMWF only, default is ON unless otherwise stated)
if(AT_ECMWF)
    if(NOT DEFINED ENABLE_METEOGRAM)
        set(ENABLE_METEOGRAM "ON")
    endif()
else()
    set(ENABLE_METEOGRAM "OFF")
endif()


if(ENABLE_INPE)
    set(METVIEW_INPE true)
endif()





# ----------------
# look for eccodes 
# ----------------

ecbuild_find_package(NAME eccodes VERSION 2.24.0 REQUIRED)

set( GRIB_API_INCLUDE_DIRS  ${eccodes_INCLUDE_DIRS} )
set( GRIB_API_LIBRARIES     ${eccodes_LIBRARIES} )
set( GRIB_API_DEFINITIONS   ${eccodes_DEFINITIONS} )
set( GRIB_API_TPL_LIBRARIES ${eccodes_TPL_LIBRARIES} )
set( grib_api_BASE_DIR      ${eccodes_BASE_DIR} )
add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)



# --------------------
# look for MARS client 
# --------------------

ecbuild_find_package(NAME mars_client VERSION 6.28.6 REQUIRED)
ecbuild_find_package(NAME mir VERSION 1.6.1 REQUIRED)


# for the mars-client itself, RPC is not necessary, but Metview needs it,
# so abort if mars-client could not find it

if (NOT mars_client_HAVE_RPC)
    message( FATAL_ERROR "Could not find RPC libraries. Consider installing rpcgen and libtirpc-devel" )
endif()


set(MARSCLIENT_LIBS "marsclient")


# check which post-processing libraries it found
list(FIND mars_client_FEATURES "PPROC_MIR"  HAVE_PPROC_MIR)
list(FIND mars_client_FEATURES "PPROC_EMOS" HAVE_PPROC_EMOS)
if (HAVE_PPROC_MIR EQUAL -1)
    set(HAVE_PPROC_MIR 0)
else()
    set(HAVE_PPROC_MIR 1)
    list(APPEND MARSCLIENT_LIBS "mir")
endif()
if (HAVE_PPROC_EMOS EQUAL -1)
    set(HAVE_PPROC_EMOS 0)
else()
    set(HAVE_PPROC_EMOS 1)
    ecbuild_find_package(NAME libemos REQUIRED)
    list(APPEND MARSCLIENT_LIBS "emos")
endif()


if( NOT HAVE_PPROC_MIR AND NOT HAVE_PPROC_EMOS  )
    message( FATAL_ERROR "MARS client requires PPROC (for which MIR or EMOSLIB is required)" )
endif()


if(HAVE_PPROC_MIR)
    ecbuild_find_package(NAME eckit VERSION 1.0 REQUIRED)  # for DivRot, which uses eckit directly
endif()

# decide which interpolation library to use by default
if(HAVE_PPROC_MIR)
    set(DEFAULT_INTERP_PACKAGE "MIR")
else()
    set(DEFAULT_INTERP_PACKAGE "EMOS")
endif()




# look for curl because it is needed for the Mars Web API client
find_package(CURL)
if(CURL_FOUND)
    list(APPEND MARSCLIENT_LIBS ${CURL_LIBRARIES})
endif()



# local MARS access
if(ENABLE_MARS)
    set( MARS_ACCESS MARS_local )
    set( METVIEW_MARS 1 )
    #if(DEFINED MARS_LOCAL_HOME)
    #    ecbuild_info("MARS_LOCAL_HOME=${MARS_LOCAL_HOME}")
    #    if(NOT EXISTS ${MARS_LOCAL_HOME})
    #        ecbuild_critical("MARS_LOCAL_HOME (${MARS_LOCAL_HOME}) does not exist")
    #    else()
    #        set(MARS_HOME ${MARS_LOCAL_HOME})
    #    endif()
    #else()
    #    ecbuild_critical("If setting local MARS access, -DMARS_LOCAL_HOME=/path/to/mars/home must be provided.")
    #endif()


    if(NOT DEFINED MARS_COMMAND)
        set(MARS_COMMAND "mars")
    endif()
    ecbuild_info("MARS_COMMAND=${MARS_COMMAND}")

    execute_process(
        COMMAND ${MARS_COMMAND} -h
        RESULT_VARIABLE result
        OUTPUT_VARIABLE output
        ERROR_VARIABLE error_output
    )

    set(ENABLE_MARS_CMD_LINE 0)
    if(result EQUAL 1)
        string(FIND "${output}" "MARS" mars_found)
        if(mars_found GREATER -1)
            set(ENABLE_MARS_CMD_LINE 1)
            message(STATUS "MARS is available with the command line ${MARS_COMMAND}")
        else()
            message(STATUS "MARS command returns 1 and output does not contain MARS")
        endif()
    else()
        message(WARNING "MARS command-line is not available; will use built-in client")
    endif()




    list(FIND mars_client_FEATURES "ODB" HAVE_MARS_ODB)
    if (HAVE_MARS_ODB EQUAL -1)
        set(ENABLE_MARS_ODB "OFF")
    else()
        set(ENABLE_MARS_ODB "ON")
    endif()
    

    if(ENABLE_MARS_ODB)
        set(ENABLE_ODB 1)
        set(METVIEW_MARS_ODB 1)
    endif()

    #find_library( FDB  REQUIRED )
    #ecbuild_debug("FDB: ${FDB_LIBRARIES}" )

else()
    if(${CURL_FOUND})
        set( MARS_ACCESS MARS_webapi )
    else()
        set( MARS_ACCESS MARS_none )
        add_definitions(-DNOCURL)
        ecbuild_warn("Could not find the Curl library - disabling Web API Mars")
    endif()
endif()


# Network access (download via URLs)
if(ENABLE_URL_DOWNLOAD)
    if(NOT CURL_FOUND)
        ecbuild_critical("URL_DOWNLOAD was enabled, but the 'curl' development package was not found.")
    endif()
endif()



###############################################################################
# local project requirements

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )




#message(FATAL_ERROR "ECCODES_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS}")


if(ENABLE_ODB)
    ecbuild_find_package(NAME odc    VERSION 1.1.0 REQUIRED)
    if( odc_FOUND )
        set(METVIEW_ODB_API_LIBRARIES odccore)
        set(METVIEW_ODB 1)

        add_definitions(-DMETVIEW_ODB_NEW -DMETVIEW_ODB)
    else()
        if(ENABLE_MARS_ODB)
            ecbuild_critical("ENABLE_ODB was set, but ODB not found")
            set(ENABLE_MARS_ODB 0)
            set(METVIEW_MARS_ODB 0)
        endif()
    endif()

    # ODB-1

    #ecbuild_use_package( PROJECT ODB )
    ecbuild_find_package(NAME odb)

    if(odb_FOUND)
        if(EXISTS ${ODB_PATH}/bin)
            if(EXISTS ${ODB_PATH}/bin/odbsql)
                add_definitions(-DMETVIEW_ODB_OLD)
                set(ENABLE_ODB1 "ON")

                if(ODB1_USE_SCRIPT) # was an ODB-1 use script name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_USE_SCRIPT=${ODB1_USE_SCRIPT}")
                endif()

                if(ODB1_MODULE) # was an ODB-1 module name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_MODULE=${ODB1_MODULE}")

=== mir/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


cmake_minimum_required(VERSION 3.14 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project(mir LANGUAGES CXX)

set(PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "") # needed for generating .b files for persistent support
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


ecbuild_add_option(FEATURE BUILD_TOOLS        DEFAULT OFF DESCRIPTION "build the command line tools (install)")
ecbuild_add_option(FEATURE MIR_DOWNLOAD_MASKS DEFAULT ON  DESCRIPTION "download LSM files")
ecbuild_add_option(FEATURE NETCDF             DEFAULT ON  DESCRIPTION "support for netCDF" REQUIRED_PACKAGES "NetCDF COMPONENTS C CXX")
ecbuild_add_option(FEATURE PNG                DEFAULT OFF DESCRIPTION "support for PNG encoding" REQUIRED_PACKAGES PNG)
ecbuild_add_option(FEATURE OMP                DEFAULT OFF DESCRIPTION "support for OpenMP shared memory parallelism" REQUIRED_PACKAGES "OpenMP COMPONENTS CXX")

if(NOT TARGET OpenMP::OpenMP_CXX)
    set(mir_HAVE_OMP 0)
endif()

ecbuild_find_package(NAME eccodes VERSION 2.40 REQUIRED)
ecbuild_find_package(NAME eckit   VERSION 1.31 REQUIRED)

ecbuild_add_option(FEATURE ATLAS DEFAULT ON DESCRIPTION "support for Atlas" REQUIRED_PACKAGES "atlas VERSION 0.36")

if(NOT TARGET eckit_geo)
    MESSAGE(FATAL_ERROR "eckit::geo (feature ECKIT_GEO) is required but not found")
endif()

# shortcut upstream features into mir features (avoid additional optional behaviour)
set(mir_HAVE_ECKIT_CODEC eckit_HAVE_ECKIT_CODEC)
set(mir_HAVE_GRID_FESOM eckit_HAVE_GEO_GRID_FESOM)
set(mir_HAVE_GRID_ICON eckit_HAVE_GEO_GRID_ICON)
set(mir_HAVE_GRID_ORCA eckit_HAVE_GEO_GRID_ORCA)

set(MIR_LIBRARIES mir)

if(HAVE_BUILD_TOOLS)
    set(mir_INSTALL_TOOLS)
else()
    set(mir_INSTALL_TOOLS NOINSTALL)
endif()

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

add_subdirectory(src)
add_subdirectory(etc)
add_subdirectory(share)

if(HAVE_TESTS)
    add_subdirectory(tests)
endif()


ecbuild_add_resources(TARGET ${PROJECT_NAME}_top_files SOURCES AUTHORS README.md NOTICE LICENSE INSTALL COPYING)
ecbuild_install_project(NAME ${PROJECT_NAME})

ecbuild_print_summary()

=== atlas/hic/CMakeLists.txt ===
# (C) Copyright 2024- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# hic

cmake_minimum_required( VERSION 3.18 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild ${CMAKE_CURRENT_SOURCE_DIR}/../../ecbuild )

################################################################################
# Initialise project

if( NOT DEFINED atlas_VERSION )
  set( atlas_VERSION 0.0.0 )
endif()

project( hic VERSION ${atlas_VERSION} LANGUAGES CXX )

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################################################################################
# Features that can be enabled / disabled with -DENABLE_<FEATURE>

ecbuild_add_option( FEATURE CUDA DESCRIPTION "Use CUDA as backend to HIC" DEFAULT OFF )
ecbuild_add_option( FEATURE HIP  DESCRIPTION "Use HIP as backend to HIC"  DEFAULT OFF )

if( HAVE_CUDA )
  find_package(CUDAToolkit REQUIRED)
elseif( HAVE_HIP )
  find_package(hip CONFIG REQUIRED)
  find_package(hipsparse CONFIG REQUIRED)
endif()

ecbuild_add_option( FEATURE WARNINGS
                    DEFAULT ON
                    DESCRIPTION "Add warnings to compiler" )

if(HAVE_WARNINGS)
  ecbuild_add_cxx_flags("-Wall"      NO_FAIL NAME hic_cxx_Wall QUIET)
  ecbuild_add_cxx_flags("-Wextra"    NO_FAIL NAME hic_cxx_Wextra QUIET)
  ecbuild_add_cxx_flags("-Wpedantic" NO_FAIL NAME hic_cxx_Wpedantic QUIET)
endif()

ecbuild_add_option( FEATURE WARNING_AS_ERROR
                    DEFAULT OFF
                    DESCRIPTION "Treat compile warning as error" )

if(HAVE_WARNING_AS_ERROR)
  ecbuild_add_cxx_flags("-Werror" NO_FAIL NAME pluto_cxx_warning_as_error QUIET)
endif()

if( CMAKE_CXX_COMPILER_ID STREQUAL Intel )
  ecbuild_add_cxx_flags("-diag-disable=10441" NO_FAIL)   # Deprecated classic compiler
endif()

add_subdirectory( src )
add_subdirectory( tests )

################################################################################
# Export and summarize

ecbuild_add_resources(
    TARGET hic-others
    SOURCES_PACK
        README.md
        CHANGELOG.md
        LICENSE
)

ecbuild_install_project( NAME hic )
ecbuild_print_summary()

=== eckit/doc/CMakeLists.txt ===
ecbuild_add_option(
  FEATURE DOCS
  DESCRIPTION "Generate reference documentation"
  REQUIRED_PACKAGES "Doxygen" )

if( HAVE_DOCS )

  set( ECKIT_DOC eckit_doc )
  if( PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
    set( ECKIT_DOC doc )
  endif()

  set( DOXYFILE Doxyfile CACHE INTERNAL "Doxygen filename" )
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DOXYFILE}.in "${CMAKE_CURRENT_BINARY_DIR}/${DOXYFILE}" @ONLY )
  add_custom_target( ${ECKIT_DOC}
  COMMAND doxygen ${CMAKE_CURRENT_BINARY_DIR}/${DOXYFILE}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )
endif()

=== mars-client/src/CMakeLists.txt ===
### config headers

# if we are not building inside the mars-client-bundle we won't have this defined
if(NOT DEFINED MARSCLIENT_VERSION_STR )
  set(MARSCLIENT_VERSION_STR ${MARS_CLIENT_VERSION_STR})
endif()

configure_file( mars_client_version.h.in  mars_client_version.h )
configure_file( mars_client_version.c.in  mars_client_version.c )

# compile definitions

ecbuild_generate_config_headers()

configure_file( mars_client_config.h.in    mars_client_config.h   )

# install generated headers

install(FILES
			${CMAKE_CURRENT_BINARY_DIR}/mars_client_version.h
			${CMAKE_CURRENT_BINARY_DIR}/mars_client_config.h
		DESTINATION
			${INSTALL_INCLUDE_DIR}/marsclient )

add_definitions( -DR64 )

if( ECMWF )
    add_definitions( -DECMWF )
endif()

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
	message( STATUS "System is big endian" )
else()
	message( STATUS "System is little endian" )
	add_definitions(-DLITTLE_END)
endif()

if( NOT HAVE_FDB )
    add_definitions(-DNOFDB)
endif()

if( NOT HAVE_FDB5 )
    add_definitions(-DNOFDB5)
endif()

if( NOT HAVE_ODB )
	add_definitions(-DNOODB)
else()
	add_definitions(-DODB_SUPPORT )
	include_directories( ${ODB_API_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS} )
endif()

if( HAVE_PPROC_EMOS )
    list( APPEND mars_client_src_files pproc_emos.cc )
endif()

if( HAVE_PPROC_MIR )
    list( APPEND mars_client_src_files pproc_mir.cc )
endif()

if( NOT HAVE_CURL )
	add_definitions(-DNOCURL)
endif()

if(HAVE_ECMWF_DEVELOPMENT)
  add_definitions(-DECMWF)
  add_definitions(-DNOEMS)
  add_definitions(-DNOAUTH)
  add_definitions(-DNOSCHEDULE)
endif()

# sources

list( APPEND mars_client_src_files
account.c
archive.c
authenticate.c
base.c
bufr.c
calc.c
certify.c
check.c
control.c
cos.c
ecaccess.c
eccert.c
environ.c
expand.c
extargs.c
externf.c
fdb5base.cc
forwardbase.c
feedtask.c
field.c
filebase.c
files.c
flatfilebase.c
free.c
gribbase.c
grib.c
guess.c
handler.c
hash.c
hidden.c
hypercube.c
ibmblk.c
index.c
langy.c
list.c
lock.c
logfile.c
mcs.c
memory.c
dhsbase.c
metadata.c
msbase.c
multibase.c
netbase.c
netcdf.c
hdf5.c
nfdbbase.c
nullbase.c
options.c
pproc.h
pproc.cc
pproc_none.cc
queue.c
rdb.c
remove.c
request.c
restricted.c
retrieve.c
schedule.c
server.c
service.c
sh2ll.c
statistics.c
stream.c
target.c
chunked.c
tcp.c
proxies.c
time.c
timer.c
tools.c
udp.c
variable.c
version.c
json.c
api.c
apibase.c
wind.c)

if(HAVE_UDP_STATS)
  list(APPEND mars_client_src_files udp_statistics.cc)
endif()

if(HAVE_NETCDF)

  list(APPEND mars_client_src_files
    nctarget.c
    nctypes.c
    ncschema.c
    ncmerge.c
    )

endif()

if(HAVE_ODB)
    list(APPEND mars_client_src_files
        odb.cc
    )
endif()

ecbuild_find_lexyacc()
if(FLEX_FOUND)
    set(_lex ${FLEX_EXECUTABLE})
elseif(LEX_FOUND)
    set(_lex ${LEX_EXECUTABLE})
else()
    ecbuild_critical("Found neither flex nor lex")
endif()

if(YACC_FOUND)
    set(_yacc ${YACC_EXECUTABLE})
elseif(BISON_FOUND)
    set(_yacc ${BISON_EXECUTABLE} -y)
else()
    ecbuild_critical("Found neither yacc nor bison")
endif()

if(mars_client_HAVE_RPC)

  list( APPEND mars_client_src_files marsxdr.c )
  list( APPEND mars_client_deps marsxdr )

  if( DEFINED RPCGEN_PATH )
      find_program( RPCGEN_EXECUTABLE NAMES rpcgen PATHS ${RPCGEN_PATH} PATH_SUFFIXES bin NO_DEFAULT_PATH )
  endif()
  find_program( RPCGEN_EXECUTABLE NAMES rpcgen )
  if( NOT RPCGEN_EXECUTABLE )
    ecbuild_critical("Could not find rpcgen. Please provide RPCGEN_PATH.")
  endif()

  # targets

  configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rpcmars.x ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x COPYONLY )

  add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
      COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
      COMMAND ${RPCGEN_EXECUTABLE} -h -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

  add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
      COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
      COMMAND ${RPCGEN_EXECUTABLE} -c -o ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

  add_custom_target(marsxdr DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c)

  list(APPEND _make_cleans rpcmars.h marsxdr.c )

endif()

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langl.c
	  COMMAND ${_lex} -l ${CMAKE_CURRENT_SOURCE_DIR}/langl.l\; sed -e s/yy/yy_mars/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/langl.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langl.l)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langy.c
	  COMMAND ${_yacc} -t ${CMAKE_CURRENT_SOURCE_DIR}/langy.y\; sed -e s/yy/yy_mars/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/langy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langy.y)

list(APPEND _make_cleans langl.c langy.c )

add_custom_target(marslex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/langy.c ${CMAKE_CURRENT_BINARY_DIR}/langl.c)
list( APPEND mars_client_deps marslex)

set_directory_properties( ADDITIONAL_MAKE_CLEAN_FILES  ${_make_cleans} )

set( grib_handling_pkg eccodes )

set(MARSC_HEADER_FILES_TO_INSTALL
        api.h
        base.h
        bufr.h
        control.h
        cos.h
        field.h
        globals.h
        grib.h
        hypercube.h
        index.h
        json.h
        lang.h
        mars.h
        nctarget.h
        proto.h
        hash.h
        tools.h
        variable.h
)

if(mars_client_HAVE_RPC)
  list(APPEND MARSC_HEADER_FILES_TO_INSTALL ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h)
endif()

ecbuild_add_library(
  TARGET      marsclient
  GENERATED   mars_client_version.c
  INSTALL_HEADERS_LIST ${MARSC_HEADER_FILES_TO_INSTALL}
  HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/marsclient

	SOURCES
      ${mars_client_src_files}
      mars_client_version.c
	DEPENDS
      ${mars_client_deps}

  PUBLIC_INCLUDES
       $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
       $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
       ${RPC_INCLUDE_DIRS}

  PRIVATE_INCLUDES
        ${ECKIT_INCLUDE_DIRS}
        ${MARS_SERVER_INCLUDE_DIRS}
        ${FDB5_INCLUDE_DIRS}
        ${MIR_INCLUDE_DIRS}
        ${CURL_INCLUDE_DIRS}

  PUBLIC_LIBS
        eccodes
        ${RPC_LIBRARIES}

  PRIVATE_LIBS
        ${FDB5_LIBRARIES}
        ${MARS_FEATURE_LIBRARIES}
        ${CURL_LIBRARIES}
        ${CMATH_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
)

set(_marsbin_noinstall NOINSTALL) # still needed for the tests
if(HAVE_BUILD_TOOLS)
  set(_marsbin_noinstall)
endif()
ecbuild_add_executable(
    TARGET    mars.bin
    INCLUDES  ${MIR_INCLUDE_DIRS} ${LIBEMOS_INCLUDE_DIRS}
    SOURCES   mars.c
    LIBS      marsclient ${MARS_FEATURE_LIBRARIES}
    ${_marsbin_noinstall}
)

ecbuild_add_executable(
    NOINSTALL
    TARGET    test-udp-stats
    SOURCES   test-udp-stats.c
    CONDITION HAVE_UDP_STATS
    LIBS      marsclient
)

if(HAVE_BUILD_TOOLS)
  add_subdirectory( tools )
endif()

=== mars-client/tests/CMakeLists.txt ===
find_program( GRIB_COMPARE grib_compare )
if( NOT GRIB_COMPARE AND TARGET grib_compare )
    set( GRIB_COMPARE "$<TARGET_FILE:grib_compare>" )
endif()

find_program( GRIB_LS grib_ls )
if( NOT GRIB_LS AND TARGET grib_ls )
    set( GRIB_LS "$<TARGET_FILE:grib_ls>" )
endif()

ecbuild_add_test(
    TARGET test_${V}_${T}
    ENABLED OFF
    TYPE SCRIPT
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_${V}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${V}/${R}
)

if( GRIB_COMPARE )
    message( STATUS "tests will use grib_compare: ${GRIB_COMPARE}" )
else()
    message( WARNING "Could not find grib_compare executable -- turning off ${PROJECT_NAME} tests!\nTo enable them place 'grib_compare' on the PATH and re-run cmake" )
endif()

# define the grib environment

set( grib_handling_pkg eccodes )

set( GRIB_DEFINITION_PATH ${eccodes_BASE_DIR}/share/eccodes/definitions/ )
set( GRIB_SAMPLES_PATH    ${eccodes_BASE_DIR}/share/eccodes/samples/ )

set( mars_new_binary "$<TARGET_FILE:mars.bin>" )

ecbuild_configure_file( run_mars.sh.in ${CMAKE_CURRENT_BINARY_DIR}/run_mars.sh @ONLY )

# mars ems permissions
set( USER $ENV{USER} )
ecbuild_configure_file( ems_cache_prod.in ${CMAKE_CURRENT_BINARY_DIR}/ems_cache_prod @ONLY )

#### TESTS

# To add a test, just add the mars request with a .req extension
# and make sure the target=testdata which automatically gets substituted to testdata.prod and testdata.test

list( APPEND _test_reqs
compute.req
interpolation_wave.req
interpolation_gaussian.req
interpolation_l137.req
interpolation_rgg2ll.req
#interpolation_t1279_gg.req  # Creates very large coefficient file
#interpolation_t1279_sh.req  # Creates very large coefficient file
#interpolation_rotated.req   # Failing in ECMWF bundle with Intel
# interpolation_latlon.req   # comparison data no longer correct
# interpolation_sh2ll.req    # comparison data no longer correct
transform_vod2uv.req
retrieve_oper.req
retrieve_enfo.req
#retrieve_ocean.req  # MIR doesn't support GRIB localDefinitionNumber=4
retrieve_fdb_uv_pl.req
retrieve_fdb_uv_ml.req
# retrieve_ai.req
# retrieve_tigge.req
MARSC-94.req
# MARSC-100.001.req
# MARSC-100.002.req
)

if(HAVE_ODB)
    list( APPEND _test_reqs
        #odb_filter_updated.req       # As a result of ODB-159 the default codec has changed from short_real to short_real2
        # odb_filter_odc.req            # ODC removed the unused Flags entries
        )
endif()

if(eccodes_HAVE_JPG)
    list( APPEND _test_reqs MARSC-86.req ) # contains jpeg-encoded data
endif()

foreach( t ${_test_reqs} )
    list( APPEND _test_data ${t}.refdata.mir ${t}.inpdata )
endforeach()

ecbuild_get_test_multidata( TARGET get_configs NAMES mars-client-test-configs.tar.gz:15bfc319ff03a6db165f1096cc468fd8 EXTRACT )

ecbuild_get_test_multidata( TARGET get_data NAMES ${_test_data} )

ecbuild_add_resources( TARGET tests_run_mars SOURCES_PACK ${_test_reqs} )

set( MIR_HOME ${CMAKE_CURRENT_BINARY_DIR} )
if( EXISTS "${CMAKE_BINARY_DIR}/etc/mir/config.yaml" )  # for bundles
    set( MIR_HOME ${CMAKE_BINARY_DIR} )
elseif( EXISTS "${mir_BASE_DIR}/etc/mir/config.yaml" )  # for individual packages
    set( MIR_HOME ${mir_BASE_DIR} )
endif()

foreach( _req ${_test_reqs} )

    string(REGEX REPLACE "[^A-Za-z0-9]" "_" _tst ${_req})

    ecbuild_add_test(
        TARGET test_${_tst}
        TYPE SCRIPT
        COMMAND ${CMAKE_CURRENT_BINARY_DIR}/run_mars.sh
        ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${_req}
        TEST_DEPENDS get_data get_configs
        ENVIRONMENT
            TESTS_DIR=${CMAKE_CURRENT_BINARY_DIR}
            MARS_HOME=${CMAKE_CURRENT_BINARY_DIR}
            MARS_PPROC_BACKEND=MIR
            MIR_HOME=${MIR_HOME}
    )

endforeach()

=== metview/scripts/CMakeLists.txt ===

set(scripts
    dump metview-mail mvrun mvrun_c mvrun_lnx
    logrun metview_stat metview_create_user_dir
    metview_patches
    mvusage metview_help set_mars_env
    document_macros.pl mv_grib_dump
    metview_local.${MV_ENVIRON} metview_local2.${MV_ENVIRON}
    MarsTiggeWrapper
    MarsOdbWrapper
    MarsCmdLineWrapper
    generate_video
    mv_compress mv_mail
    mv_extract
    mv_eccharts.py
    mv_odbsql
    mv_mars_catalog.py
    mv_flextra_prep.mv mv_flextra_prep mv_flextra_run
    mv_flexpart_run mv_flexpart_pp
    mv_met3d_prep.mv
    mv_preview.mv
    mv_rttov_run
    mv_scm_run mv_scm_vis.mv
    mv_vapor_prep.mv mv_vapor_gui
    select_mars_config
)

set(generated_scripts )

if(AT_ECMWF)
    list(APPEND scripts mv_debug_env.sh)
endif()

if(HAVE_PPROC_MIR)
    list(APPEND scripts MarsMirWrapper DivrotMirWrapper)
endif()

if(HAVE_PPROC_EMOS)
    list(APPEND scripts MarsEmosWrapper DivrotEmosWrapper)
endif()

if(ENABLE_STVL)
    list(APPEND generated_scripts mv_stvl)
endif()



# handle these script files

foreach( script ${scripts} )
    # ensure that the target/dependency relationship is correct
    configure_file( ${script} ${CMAKE_BINARY_DIR}/bin COPYONLY)

    # copy to the build 'bin' directory, setting exe permissions
    file(COPY ${script}
         DESTINATION ${CMAKE_BINARY_DIR}/bin
         FILE_PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ OWNER_EXECUTE GROUP_EXECUTE
         )
endforeach()


foreach( script ${generated_scripts} )
    configure_file( "${script}.in" ${CMAKE_BINARY_DIR}/bin/${script} @ONLY)
endforeach()


foreach( script ${scripts} ${generated_scripts} )
    # ensure file is installed at install time
    install( FILES ${CMAKE_BINARY_DIR}/bin/${script}
             DESTINATION ${MV_BIN_DIR}
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)
endforeach()






# remove unnecessary items from a colon-separated list (e.g. /usr/lib64, which can interfere if we use non-default compilers)
function(removeUnwantedCompileItemsFromColonString colonString)
    string (REPLACE ":"  ";"   LOC_AS_LIST "${${colonString}}")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib64")
    string (REPLACE ";"  ":"   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${colonString} ${LOC_AS_STRING} PARENT_SCOPE)
endfunction()


# remove non-compiler items and unnecessary items from the string
function(removeUnwantedCompileItems compileList)
    set(loc ${${compileList}})
    list(REMOVE_ITEM loc "debug")        
    list(REMOVE_ITEM loc "optimized")
    list(REMOVE_ITEM loc "/usr/lib")
    list(REMOVE_ITEM loc "/usr/lib64")
    list(REMOVE_ITEM loc "-L/usr/lib")
    list(REMOVE_ITEM loc "-L/usr/lib64")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib64")

    # items could themselves be lists, e.g. rpath=/usr/lib:/usr/local/lib
    foreach (item ${loc})
        set(item1 ${item})
        removeUnwantedCompileItemsFromColonString(item1)
        list(APPEND final_result ${item1})
    endforeach()

    set (${compileList} ${final_result} PARENT_SCOPE)
endfunction()


function(removeUnwantedCompileItemsFromString compileString)
    # convert from string to list, remove items, then convert back to string
    string (REPLACE " "  ";"   LOC_AS_LIST "${${compileString}}")
    removeUnwantedCompileItems(LOC_AS_LIST)
    string (REPLACE ";"  " "   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${compileString} " ${LOC_AS_STRING}" PARENT_SCOPE) # preserve leading space
endfunction()



##############################################################
#
# generate the 'compile' script for inline C/Fortran in Macro




# for GRIB_API, we *might* get something like
# grib_api;grib_api_f77;grib_api_f90;/usr/lib64/libjasper.so;/usr/lib64/libjpeg.so;/usr/lib64/libm.so
# which is not all that we need to link. So we convert 'grib_api' into '-lgrib_api'
# and for the Fortran libraries.

#get_target_property(OUT marsclient LINK_LIBRARIES)
#message(STATUS "LINK_LIBRARIES ${OUT}")
#get_target_property(OUT marsclient INCLUDE_DIRECTORIES)
#message(STATUS "INCLUDE_DIRECTORIES ${OUT}")
#get_target_property(OUT marsclient INTERFACE_INCLUDE_DIRECTORIES)
#message(STATUS "INTERFACE_INCLUDE_DIRECTORIES ${OUT}")
#get_target_property(OUT marsclient INTERFACE_LINK_LIBRARIES)
#message(STATUS "INTERFACE_LINK_LIBRARIES ${OUT}")
#message(STATUS  "GRIB_API_LIBRARIES : ${GRIB_API_LIBRARIES}")

set(GRIB_API_LIBRARIES_STR " ${GRIB_API_LIBRARIES}") # add a space to the beginning

string (REPLACE ";"         " "           GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
set (GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR} -leccodes")

if (HAVE_METVIEW_FORTRAN)
    set (GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR} -leccodes_f90")
endif()

set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${PTHREAD_LIB}") # add pthread in case needed


# we may need to add the netCDF lib dir to the rpath. We don't seem to have a variable
# which tells us this directly, so we need to make an educated guess...
if(DEFINED NETCDF_INCLUDE_DIR)
    set(NETCDF_LIB_RPATH "-Wl,-rpath,${NETCDF_INCLUDE_DIR}/../lib64:${NETCDF_INCLUDE_DIR}/../lib")
    set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${NETCDF_LIB_RPATH}")
endif()

set(GRIB_API_LIBRARIES_STR_ORIGINAL "${GRIB_API_LIBRARIES_STR}")       # keep a backup for later


# if we are linking with shared GRIB_API libraries, then in order to be able
# to run compiled inline Fortran/C/Macro programs, we will need to set
# LD_LIBRARY_PATH to where GRIB_API was installed (this should only be
# needed if GRIB_API was installed in a non-default location).

# print all variables
#get_cmake_property(_variableNames VARIABLES)
#foreach (_variableName ${_variableNames})
#    ecbuild_info("${_variableName}=${${_variableName}}")
#endforeach()

# first, if GRIB_API_PATH is not defined, then we need to compute the path
set( grib_handling_pkg grib_api )
if( eccodes_FOUND )
  set( grib_handling_pkg eccodes )
endif()
if(NOT GRIB_API_PATH)
    ###get_property(GRIB_LIB_PATH TARGET ${grib_handling_pkg} PROPERTY LIBRARY_OUTPUT_DIRECTORY)
    ###$<TARGET_FILE:odc>
    if(GRIB_LIB_PATH)
        set(GRIB_API_PATH ${GRIB_LIB_PATH}/..)
    else()
        if (grib_api_BASE_DIR)
            set(GRIB_API_PATH ${grib_api_BASE_DIR})
        else()
            if(CMAKE_PREFIX_PATH)
                set(GRIB_API_PATH ${CMAKE_PREFIX_PATH})
            endif()
        endif()
    endif()
    ecbuild_info("Computed GRIB_PATH: ${GRIB_API_PATH}")
endif()


if(GRIB_API_PATH)
    set(GRIB_API_RPATH "${GRIB_API_PATH}/lib:${GRIB_API_PATH}/lib64")
endif()


# for each of the GRIB library's dependencies, we should find the directory name
# and add it to the -L and to the rpath

foreach (gtpl ${GRIB_API_TPL_LIBRARIES})
    get_filename_component(gtpl_i ${gtpl} PATH)  # DIRECTORY only in CMake > 2.8.12+
    list(APPEND GRIB_LIB_TPL_DIRS ${gtpl_i})
endforeach()

if (GRIB_LIB_TPL_DIRS)
    list(REMOVE_DUPLICATES GRIB_LIB_TPL_DIRS)
    string (REPLACE ";" ":"   GRIB_LIB_TPL_RPATH    "${GRIB_LIB_TPL_DIRS}")
endif()
set(GRIB_API_RPATH "${GRIB_API_RPATH}:${GRIB_LIB_TPL_RPATH}")

set(GRIB_API_LIBRARIES_STR "-L${GRIB_API_PATH}/lib -L${GRIB_API_PATH}/lib64 -Wl,-rpath,${GRIB_API_RPATH} ${GRIB_API_LIBRARIES_STR}")
removeUnwantedCompileItemsFromString(GRIB_API_LIBRARIES_STR)


# add the GRIB include directories to the compiler directives
if(DEFINED GRIB_API_INCLUDE_DIRS)
    # linking with external eccodes
    foreach (inc ${GRIB_API_INCLUDE_DIRS})
        set(GRIB_API_INCLUDE_DIRS_STR "${GRIB_API_INCLUDE_DIRS_STR} -I${inc}")
    endforeach()
else()
    # linking with eccodes in a bundle
    set(GRIB_API_INCLUDE_DIRS_STR "-I${eccodes_BASE_DIR}/include -I${eccodes_BINARY_DIR}/src -I${eccodes_BINARY_DIR}/src/eccodes -I${eccodes_SOURCE_DIR}/src/eccodes -I${eccodes_SOURCE_DIR}/src")
endif()
list(APPEND METVIEW_INLINE_DEFINITIONS ${GRIB_API_DEFINITIONS})

#
# something similar for fdb
#

if(fdb_FOUND)
    if(fdb_LIBRARY)  # fdb in bundle
        get_filename_component(FDB_LIB_DIR ${fdb_LIBRARY} PATH)
        set(FDB_LIBRARIES_STR "${FDB_LIBRARY} -Wl,-rpath,${FDB_LIB_DIR}")
    else()           # fdb not in bundle
        foreach(fdblib ${FDB_LIBRARIES})
            set(FDB_MINUS_L_LIBS " -l${fdblib} ${FDB_MINUS_L_LIBS}")
        endforeach()
        set(FDB_LIBRARIES_STR "")
        set(libdirs lib lib64)
        foreach(libdir ${libdirs})
            set(FDB_LIBRARIES_STR "-Wl,-rpath,${fdb_BASE_DIR}/${libdir} -L${fdb_BASE_DIR}/${libdir} ${FDB_LIBRARIES_STR}")
        endforeach()
        set(FDB_LIBRARIES_STR "${FDB_MINUS_L_LIBS} ${FDB_LIBRARIES_STR}")
    endif()
endif()


# in the case of a static libemos, we may need to be explicit about about the Fortran libraries when
# building inline C
foreach(fortlib ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})
    set(IMPLICIT_FORTRAN_LIBS "-l${fortlib}  ${IMPLICIT_FORTRAN_LIBS}")
endforeach()



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile @ONLY)



# in the case of a bundle, the GRIB_API and emoslib locations will have been
# set to their build directories, which is correct when running from 
# the build directory, but not once installed, so we have to change these
# to the location where they will be installed, and create another 'compile'
# script which is the one that will actually be installed. In the case where
# we're not building a bundle, these two compile scripts will be identical.

# this checks if ECCODES is inside a bundle with us
if(MV_BUNDLE_CONTAINS_ECCODES)
    set(GRIB_API_LIBRARIES_STR    "-L${CMAKE_INSTALL_PREFIX}/lib ${GRIB_API_LIBRARIES_STR_ORIGINAL}")
    set(GRIB_API_INCLUDE_DIRS_STR "-I${CMAKE_INSTALL_PREFIX}/include")
    set(GRIB_API_PATH ${CMAKE_INSTALL_PREFIX})
endif()

# this checks if emoslib is inside a bundle with us
if(MV_BUNDLE_CONTAINS_EMOSLIB)
	string(REPLACE "${CMAKE_BINARY_DIR}/lib"  "${CMAKE_INSTALL_PREFIX}/lib"  EMOS_LIBRARIES_STR  "${EMOS_LIBRARIES_STR}")
endif()


# it would be nice to be a bit neater here, but this aspect is hard-coded in ecCodes
# and the fact that the path for MMFS definitions is in /MEMFS is not accessible
# from CMake, so we need to duplicate that piece of information here

if(eccodes_HAVE_MEMFS)
    set(GRIB_API_SHARE_DIR "/MEMFS")
else()
    set(GRIB_API_SHARE_DIR "${GRIB_API_PATH}/share/${grib_handling_pkg}")
endif()


# export upwards so that CodesUI can use it if need be
set (GRIB_API_PATH ${GRIB_API_PATH} PARENT_SCOPE)


if( DEFINED NETCDF_PATH )
    set(NETCDF_BIN "${NETCDF_PATH}/bin")
else()
    set(NETCDF_BIN "")
endif()

if(MV_BUNDLE_CONTAINS_METVIEW)
    set(METVIEW_BUNDLE_SRC ${CMAKE_SOURCE_DIR})
endif()

if(MV_BUNDLE_CONTAINS_MAGICS)
    set(MV_BUNDLE_MAGICS_SRC ${CMAKE_SOURCE_DIR}/magics)
endif()


configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile_install @ONLY)



install( FILES ${CMAKE_BINARY_DIR}/bin/compile_install  
         DESTINATION ${MV_BIN_DIR}
         RENAME      compile
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)




##################
#
# for metview_base





ecbuild_get_date(TODAYS_DATE)


# # Add certain paths to LD_LIBRARY_PATH.
# # If the given path is not a standard system one, then add it to our list
# # of paths to add to LD_LIBRARY_PATH on Metview's startup. We want to
# # avoid adding system paths here because they can override non-default
# # paths (case in point: the wrong OpenGL library has been known to be
# # picked up - used by VAPOR).
#
# NO - this is not really needed with the rpath, and it can lead, in the
# case of a bundle, to the build directory (Magics) going into the
# LD_LIBRARY_PATH even when installed (no harmful effect seen though).
# 
# set(SYS_LIBDIRS "/usr/lib64" "/usr/lib64/" "/usr/lib" "/usr/lib/" "")
# set(METVIEW_LD_PATHS "")
# 
# foreach(LIBPATH ${MAGICS_LIB_DIR} ${ODB_API_LIB_DIR} ${GRIB_API_LIB_DIR})

=== metview/share/CMakeLists.txt ===

add_subdirectory(metview/app-defaults)

add_subdirectory(metview/etc)

add_subdirectory(metview/icons_mv5)

add_subdirectory(metview/eccharts)



#install ( DIRECTORY metview
#          DESTINATION share FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

## NEED TO COPY TO BUILD DIRECTORY!!!!

#configure_file(metview ../share COPYONLY)

=== metview/test/CMakeLists.txt ===

add_subdirectory( macros )
add_subdirectory( convert )

=== debian/changelog ===
metview (5.26.1-1) unstable; urgency=medium

  * New upstream release
  * Add perl:Depends to metview
	
 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 23 Oct 2025 10:25:53 +0100

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-2),
  gfortran | fortran-compiler, 
  python3-all-dev,
  libgeotiff-dev,
  flex, 
  bison, 
  libtirpc-dev,
  libncurses-dev,
  libjemalloc-dev,
  libpng-dev,
  libssl-dev,
  libhdf5-dev, 
  liblapack-dev,
  libpango1.0-dev, 
  libmetkit-dev,
  libmetkit-utils,
  fdb5,
  libfdb5-dev (>= 5.16.1~),
  odc,
  libodc-dev,
  libfftw3-dev,
  libeigen3-dev,
  chrpath, 
  mksh,
  libfckit-dev,
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  libvulkan-dev,
  libxkbcommon-dev,
  libemos-dev, libemos-bin,
  libeccodes-dev (>= 2.22.0),
  libeccodes-tools,
  libatlas-ecmwf-dev (>= 0.42.0~), 
  libatlas-ecmwf-utils,
  libeckit-dev (>= 1.10.1~),
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev (>= 4.12.1-2), 
  libmagics++-dev (>= 4.12.1-2),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkgconf,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, 
  flextra, 
  flexpart
Standards-Version: 4.7.2
Homepage: https://confluence.ecmwf.int/display/METV/Metview
Vcs-Browser: https://salsa.debian.org/science-team/metview.git
Vcs-Git: https://salsa.debian.org/science-team/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3, ${perl:Depends}
Recommends: magics++, flextra, flexpart
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version}), 
 libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1


DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# DEB_LDFLAGS_MAINT_PREPEND:= -Wl,-z,defs -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
DEB_CXXFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_PREPEND
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) -std=gnu++17 -I /usr/include/eigen3


# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

# Code should import these from eccodes-import but doesn't
export ECCODES_SAMPLES_PATH=/usr/share/eccodes/samples
export ECCODES_DEFINITION_PATH=/usr/share/eccodes/definitions
export ECCODES_IFS_SAMPLES_PATH=/usr/share/eccodes/ifs_samples

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin
export BUILDDIR=$(METVIEW_DIR_DEV)


# Hack until complter  uses this directory
FC:=$(shell basename $(shell readlink -f /usr/bin/f95))
FMODDIR:=$(LIBDIR)/fortran/$(FC)
FCFLAGS:=$(shell dpkg-buildflags --get FCFLAGS) -I $(FMODDIR)

# For bit reproducibility
LC_ALL=C
TZ=UTC+0
export LC_ALL TZ

# magic debhelper rule
%:
	dh $@ --buildsystem=ecbuild --builddirectory=$(BUILDDIR)

#override_dh_auto_clean:
#	dh_auto_clean
#	rm -f metview/src/images/metview.png

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/share/mir/masks
	( cd $(BUILDDIR)/share/mir/masks ; tar axpf $(CURDIR)/../metview_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	dh_auto_configure -- \
		-DENABLE_EXPOSE_SUBPACKAGES=On \
		-DENABLE_BUILD_TOOLS=On \
		-DENABLE_PPROC_MIR=On \
		-DENABLE_URL_DOWNLOAD=On \
		-DENABLE_MPI=On \
		-DENABLE_ODB=On \
		-DENABLE_FDB5=On \
		-DENABLE_PNG=On \
		-DENABLE_RPC=On \
		-DRPC_PATH=${LIBDIR} \
		-DENABLE_MIR_DOWNLOAD_MASKS=On \
		-DENABLE_EXPERIMENTAL=Off \
		-DENABLE_CODE_WEBHELP=Off \
		-DENABLE_CONTRIB=On \
		-DCMAKE_CXX_STANDARD=17 \
		-DCMAKE_CXX_STANDARD_REQUIRED=On \
		-DMETVIEW_SITE=debian  \
		-DMETVIEW_EXTRA_LIBRARIES='terralib -leccodes -leckit -leckit_option' \
		-DMETVIEW_EXTRA_INCLUDE_DIRS=/usr/include/terralib/kernel \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DENABLE_RPATHS=Off \
		-DENABLE_RELATIVE_RPATHS=Off \
		-DFLEXTRA_PATH=/usr/bin/flextra \
		-DDISABLE_OS_CHECK=On \
		-DCMAKE_Fortran_FLAGS='$(FCFLAGS)'  

	( cd ${METVIEW_DIR_DEV}/share ; tar axpf $(CURDIR)/../metview_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/
	# cd debian/build/share/metview/etc && $(MAKE) ObjectListAllTarget
	# cp metview/src/images/metview_logo.png metview/src/images/metview.png

override_dh_auto_test:
	# Don't fail on tests in this build
	@echo "Ignoring test failures this build"
	# -( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  )

override_dh_fixperms-arch:
	dh_fixperms
	rm -f debian/metview/usr/lib/*/metvidew/metview_post_install_tests.sh
	# chmod 755 debian/metview/$(MV_DIR)/mv_compress
	mv debian/metview/$(MV_DIR)/metview_bin/* debian/metview/$(MV_DIR)
	rmdir debian/metview/$(MV_DIR)/metview_bin
	chmod 644 debian/metview/$(MV_DIR)/metview_*.common
	chmod 644 debian/metview/$(MV_DIR)/metview_stat
	chmod 644 debian/metview/$(MV_DIR)/metview_patches
	chmod 644 debian/metview/usr/lib/*/metview/*.mv
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d
	chrpath -d debian/libmetview0d/usr/lib/*/lib*so.*

override_dh_fixperms-indep:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	find debian/metview-data/usr/share/metview -type f -exec chmod 644 {} \;
	find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \;

=== debian/watch ===
version=3
# https://software.ecmwf.int/wiki/display/METV/Releases Metview\-(.+)\-Source\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))\?api=v(.+)
https://confluence.ecmwf.int/display/METV/Releases /download/attachments/3964985/Metview\-(.+)\-Source\.tar.gz\?api=v2
